/**
* Proxy.java
*
* Created on 11 luglio 2001, 17.29
* Questa classe  l'applicazione principale del pakage Proxy. Utilizza le
* funzionalit messe a disposizione dalle classi GestioneServitori e Configura
* per monitorare le richieste che pervengono, aggiornare i profili dei clienti
* gestiti, inoltrare le richieste ai veri servitori, ricevere le rissposte e,
* infine inoltrare le risposte agli utenti.
*/

//package Proxy;


import javax.servlet.http.*;
import javax.servlet.*;

import java.net.*;

import java.io.*;
import javax.swing.text.html.*;
import Proxy.*;

/**
 *
 * @author  Luigi
 * @version
 */
public class Prox extends HttpServlet/*implements SingleThreadModel*/{
    static GestoreServitori gest_Serv;
    static GestoreClient gest_Cli;

    String fnameServ=new String("c:/Config/serv.conf");
    String fname_Cli=new String("c:/Config/clie.conf");

    private static synchronized void SettaServitori(String fname) {
        gest_Serv=new GestoreServitori();
        ObjectInputStream in;
        Object o;
        try {
            in=new ObjectInputStream(new FileInputStream(fname));
            o=in.readObject();
            if (o instanceof GestoreServitori) gest_Serv=(GestoreServitori) o;
            in.close();
        }
        catch (Exception e) {
            Servitore s= new Servitore("aaaa","bbbb","cccc");
            gest_Serv.add(e.toString(),s);
        }
    }

    public static synchronized void LeggiClient(String fname) {
        gest_Cli=new GestoreClient();
        ObjectInputStream in;
        Object o;
        try {
            in=new ObjectInputStream(new FileInputStream(fname));
            o=in.readObject();
            if (o instanceof GestoreClient) gest_Cli=(GestoreClient) o;
            in.close();
        }
        catch (Exception e) {
            Client p= new Client("aaaa","bbbb");
            gest_Cli.add(e.toString(),p);
        }
    }

    public synchronized void init(ServletConfig config) {
        try {
            super.init(config);
        }
        catch (ServletException se) {
        }
        SettaServitori(fnameServ);
        LeggiClient(fname_Cli);
    }

    private Client ControllaUtente (String user, String pass) {

      Client Cli=gest_Cli.lookup(user);
      if (Cli!=null) {
        if (pass.equals(Cli.get_Password())) return Cli;
      }
      return null;
    }

    private Servitore ControllaServitore(String id_serv) {
      return gest_Serv.lookup(id_serv);
    }

    //private URL codificaURL(){
    //}

    public synchronized void doGet (HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException {

        Client Cli;
        Servitore Serv;

        //set content type and other response header fields first
        response.setContentType("text/html");
        response.setHeader("Pragma","no-chache");
        response.setHeader("Chache-Control","no-chache");
        response.setDateHeader("Expires", 0);

        // get the communication channel with the requesting client

        PrintWriter out = response.getWriter();
        //controllo che si tratti di un cliente che devo gestire
        Cli=ControllaUtente(request.getParameter("user"), request.getParameter("pass"));
        if (Cli!=null) {
        //IL CLIENTE  STATO ACCETTATO
        //Ora devo controllare che la richiesta sia per un servitore gestito
          Serv=ControllaServitore(request.getParameter("ID_Servitore"));
          if (Serv!=null) {//IL SERVITORE E' GESTITO DAL PROXY
          //Qui devo gestire le operazioni per questo tipo di richieste
            try {
              out.println("<HTML>"
              + "<HEAD>"
              + " <TITLE>Controllo Proxy</TITLE>"
              + "</HEAD>"
              + "<BODY BGCOLOR=\"#FFFFFF\">"
              + "  <H1>Questo  il risultato della richiesta al Proxy</H1>");
              out.println("<H2>I dati del cliente sono gestiti dal Proxy</H2>");
              out.println("<H2>La richiesta sar inoltrata prima al gestore del profilo e poi al servitore</H2>");
      //INOLTRO DELLA RICHIESTA AL GESTORE PER LA MODIFICA DEL PROFILO
              StringBuffer risposta=new StringBuffer("OK");
              if (Serv.get_Id_gestore()!=null){
                risposta=new StringBuffer("");
                URL gestore= new URL(Serv.get_Id_gestore() + "?" + request.getQueryString());
                URLConnection ucgest=gestore.openConnection();
                ucgest.setDoOutput(false);
                ucgest.setDoInput(true);
                ucgest.setRequestProperty("Content-type","application/x-www-form-urlencoded");
                InputStreamReader ingest=new InputStreamReader(ucgest.getInputStream());
                int chr=ingest.read();
                while(chr!= -1) {
                  risposta.append(String.valueOf((char)chr));
                  chr=ingest.read();
                }
                ingest.close();
                //out.println(risposta.toString());
              }
              //out.println(risposta.toString());
              if (risposta.toString().equals("OK")) {
                URL servitore= new URL(Serv.get_url() + "?" + request.getQueryString());
                out.println("<H2>" +servitore.toString() + "</H2>");
                URLConnection ucserv=servitore.openConnection();
                ucserv.setDoOutput(false);
                ucserv.setDoInput(true);
                ucserv.setRequestProperty("Content-type","application/x-www-form-urlencoded");
                InputStreamReader inserv=new InputStreamReader(ucserv.getInputStream());
                StringBuffer temp=new StringBuffer(1024);
                int chr1=inserv.read();
                while (chr1 != -1) {
                  temp.append(String.valueOf((char)chr1));
                  chr1=inserv.read();
                }
                out.println(temp.toString());
              }
              else {
                out.println("I dati immessi non sono validi o c' stato un errore sul proxy");}
                out.close();
                return;
            }
            catch (Exception exce) {
              out.println("Errore sul proxy:" + exce.toString());
              out.close();
              return;
            }

          }
          else {
            //IL SERVITORE NON  GESTITO DAL PROXY
            //out.println("<H2>Il servitore non  stato accettato dal Proxy</H2>");
            //Qui devo gestire le operazioni per questo tipo di richieste
            out.println("<HTML>"
            + "<HEAD>"
            + " <TITLE>Controllo Proxy</TITLE>"
            //+ " <META NAME=\"Author\" CONTENT=\"" + serv + "\">"
            + "</HEAD>"
            + "<BODY BGCOLOR=\"#FFFFFF\">"
            + " <CENTER>"
        //default configuration just serves /jserv from localhost for security reasons
            + "  <H1>Questo  il risultato della richiesta al Proxy</H1>");
            out.println("<H2>Il cliente  gestito dal Proxy </H2>");
            out.println("<H2>Il servitore indicato non  gestibile dal Proxy </H2>");

            out.println("</CENTER>");
          }

        }
        else {
        //PER IL CLIENTE NON SI DEVE GESTIRE IL PROFILO
          //out.println("<H2>Il cliente non  stato accettato dal Proxy</H2>");
          //Ora devo controllare che la richiesta sia per un servitore gestito
          Serv=ControllaServitore(request.getParameter("ID_Servitore"));
          if (Serv!=null) {//IL SERVITORE E' GESTITO DAL PROXY
            //out.println("<H2>Il servitore  stato accettato dal Proxy</H2>");
            //Qui devo gestire le operazioni per questo tipo di richieste
            //INOLTRO LA RICHIESTA AL SERVITORE SENZA VARIARE IL RPOFILO
            try {
              out.println("<HTML>"
              + "<HEAD>"
              + " <TITLE>Controllo Proxy</TITLE>"
              //+ " <META NAME=\"Author\" CONTENT=\"" + serv + "\">"
              + "</HEAD>"
              + "<BODY BGCOLOR=\"#FFFFFF\">"
              //default configuration just serves /jserv from localhost for security reasons
              + "  <H1>Questo  il risultato della richiesta al Proxy</H1>");
              out.println("<H2>I dati del cliente non sono gestiti dal Proxy</H2>");
              out.println("<H2>La richiesta sar inoltrata al servitore senza modificare il profilo</H2>");
              URL servitore= new URL(Serv.get_url() + "?" + request.getQueryString());
              out.println("<H2>" +servitore.toString() + "</H2>");
              URLConnection uc=servitore.openConnection();
              uc.setDoOutput(false);
              uc.setDoInput(true);
              uc.setRequestProperty("Content-type","application/x-www-form-urlencoded");
              InputStreamReader ins=new InputStreamReader(uc.getInputStream());
              StringBuffer temp=new StringBuffer(1024);
              int chr=ins.read();
              while (chr != -1) {
                temp.append(String.valueOf((char)chr));
                chr=ins.read();
              }
              out.println(temp.toString());
            }
            catch (Exception exce) {
            }
          }
          else { //IL SERVITORE NON  GESTITO DAL PROXY

            //Qui devo gestire le operazioni per questo tipo di richieste
            out.println("<HTML>"
            + "<HEAD>"
            + " <TITLE>Controllo Proxy</TITLE>"
            //+ " <META NAME=\"Author\" CONTENT=\"" + serv + "\">"
            + "</HEAD>"
            + "<BODY BGCOLOR=\"#FFFFFF\">"
            + " <CENTER>"
        //default configuration just serves /jserv from localhost for security reasons
            + "  <H1>Questo  il risultato della richiesta al Proxy</H1>");
            out.println("<H2>I dati del cliente non sono gestiti dal Proxy</H2>");
            out.println("<H2>Il servitore indicato  sconosciuto</H2>");
            out.println("</CENTER>");
          }
        }
        //out.println("<H2>" + gest_Serv.table.toString() + "</H2>");
        //out.println("<H2>" + gest_Cli.table.toString() + "</H2>");
        out.println("</BODY>");
        out.println("</HTML>");
        out.close();
    }
}