

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import Proxy.*;
import java.lang.*;

/**
 * Title:        Realizzazione di un proxy per il monitoraggio richeste a dei servitori e la gestione di un profilo utente
 * Description:  Questo progetto mira a realizzare un software in grado di monitorare le richieste verso dei servitori e, sulla base di queste, gestire un profilo dell'utente stesso.
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Luigi Quitadamo
 * @version 1.0
 */

public class GestoreGiroconto extends HttpServlet implements SingleThreadModel{
  private static final String CONTENT_TYPE = "text/html";
  private String fnameProfili=new String("c:/Config/profili.data");

  /**Initialize global variables*/
  public void init(ServletConfig config) throws ServletException {
    super.init(config);
  }


  /**Process the HTTP Get request*/
  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    response.setContentType(CONTENT_TYPE);
    GestoreProfili gest_Profili;

    gest_Profili=GestoreProfili.LeggidaFile(fnameProfili);
    PrintWriter out=response.getWriter();

  //ANALIZZO LA RICHIESTA PER AGGIORNARE IL PROFILO DEL CLIENTE
    Profiloutente p=gest_Profili.lookup(request.getParameter("user"));
    if (p!=null) {
        try {
          p.incServlet();
          p.incGiroconti();
          Long importo=new Long(request.getParameter("Importo"));
          long nuovaliq=p.getLiquidita() - importo.longValue();
          p.setLiquidita(nuovaliq);
          FileOutputStream fout_prof=new FileOutputStream(fnameProfili);
          ObjectOutputStream outprof=new ObjectOutputStream(fout_prof);
          outprof.writeObject(gest_Profili);
          out.print("OK");
          out.flush();
          out.close();
        }
        catch (Exception exc) {
          out.println("NOT_OK");
          out.close();
          return;
        }
    }
    else {
      out.println("NOT_OK");
      out.close();
      return;
    }
  }

  /**Clean up resources*/
  public void destroy() {
  }
}