package Proxy;



import java.io.*;

/**
 *
 * @author  Luigi
 * @version
 * Questa classe permette di gestire completamte tutte le informazioni che
 * caratterizzano un cliente. Nella prima versione questi dati sono in misura
 * ridotta per collaudare un prototipo. In futuro si cercher di generalizzare
 * questa classe per gestire profili pi generici e configurabili (per esempio
 * sfruttando le funzionalit del protocollo CC/PP).
 */
public class Client implements Serializable{
    /*Dati che compongono l'identificazione del cliente*/
    String username;
    String pass;

    /** Creates new Client */
    public Client(String user,String p) {
        username=new String(user);
        pass=new String(p);
    }


    public String get_Username() {
        return new String(username);
    }

    public String get_Password() {
        return new String(pass);
    }
}