package Proxy;

/**
 * Title:        Realizzazione di un proxy per il monitoraggio richeste a dei servitori e la gestione di un profilo utente
 * Description:  Questo progetto mira a realizzare un software in grado di monitorare le richieste verso dei servitori e, sulla base di queste, gestire un profilo dell'utente stesso.
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Luigi Quitadamo
 * @version 1.0
 */

import java.net.*;
import java.io.*;
import java.util.*;

public class GestoreProfili implements Serializable{

  public Hashtable profili;

  public GestoreProfili() {
    profili=new Hashtable(20);
  }

  public Profiloutente add(Profiloutente p) {
        return (Profiloutente) profili.put(p.username,p);
  }

  public Profiloutente lookup(String usr) {
        return (Profiloutente) profili.get(usr);
  }

  public Profiloutente remove(String key) {
        return (Profiloutente) profili.remove(key);
  }

  public boolean update(Profiloutente p) {
        Profiloutente aux=(Profiloutente)profili.remove(p.username);
        if (aux!=null) {
          profili.put(p.username,p);
          return true;
        }
        else return false;
  }

  public static GestoreProfili LeggidaFile(String fname_Profili){
  GestoreProfili gest_Profili=new GestoreProfili();
    try {
      FileInputStream finprofili=new FileInputStream(fname_Profili);
      ObjectInputStream inprofili=new ObjectInputStream(finprofili);
      gest_Profili=(GestoreProfili) inprofili.readObject();
      inprofili.close();
      return gest_Profili;
    }
    catch (Exception e) {
      return null;
    }
  }
}