/**
* GestoreServitori.java
*
* Created on 12 luglio 2001, 23.45
*Questa classe permette di creare un oggetto che racchiude al suo interno la 
*gestione di tutti i servitori che l'applicazione deve gestire. Inoltre, questa
*classe implementa l'interfaccia Serializable per permettere al gestore del 
*Proxy di inserire i dati relativi ai servitori tramite l'applicazione Configura
*e di farli leggere dal Proxy stesso semplicemente con l'accesso ad un file.
*/

package Proxy;

/**
 *
 * @author  Luigi
 * @version 
 */

import java.io.*;
import java.util.*;

public class GestoreServitori implements Serializable {
    public Hashtable table=new Hashtable(10);

    /** Creates new GestoreServitori */
    public GestoreServitori() {
    }

    
    public Servitore lookup(String key) {
        return (Servitore) table.get(key);
    }
    
    public Servitore add(String key, Servitore s) {
        return (Servitore) table.put(key,s);
    }
    
    public Servitore remove(String key) {
        return (Servitore) table.remove(key);
    }
}